#!/usr/bin/env python

import os
from bcc import BPF

# Le programme que l'on va injecter dans le kernel
program='''
int kprobe__sys_clone(void *ctx) {
  bpf_trace_printk("Hello, eBPF!\\n");
  return 0;
}
'''

# On lance notre programme
b = BPF(text = program)

while 1:
	# Recuperation des informations envoyées par le kernel
    (task, pid, cpu, flags, ts, msg) = b.trace_fields()
	# Formattage des infos
    print("PID = %u\nPROGRAM = %s\nMESSAGE = %s\n" % (pid, task, msg))
